Package groovy.util.slurpersupport

# Class NodeChild

java.lang.Object
groovy.lang.GroovyObjectSupport
groovy.util.slurpersupport.GPathResult
groovy.util.slurpersupport.NodeChild

All Implemented Interfaces:
  `Buildable`, `GroovyObject`, `Writable`, `Iterable`

public class NodeChild extends GPathResult
Lazy evaluated representation of a child node.

Author:
  John Wilson

## Field Summary

### Fields inherited from class groovy.util.slurpersupport.GPathResult

`name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

## Constructor Summary

Constructors
Constructor
Description
`NodeChild(Node node, GPathResult parent, String namespacePrefix, Map<String,String> namespaceTagHints)`
`NodeChild(Node node, GPathResult parent, Map<String,String> namespaceTagHints)`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`appendNode(Object newValue)`
`Map`
`attributes()`
Returns a map containing all attributes of the Node of this NodeChild.
`void`
`build(GroovyObject builder)`
`Iterator`
`childNodes()`
Returns an iterator over the child nodes of this GPathResult.
`GPathResult`
`find(Closure closure)`
Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.
`GPathResult`
`findAll(Closure closure)`
Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
`Object`
`getAt(int index)`
Supports the subscript operator for a GPathResult.
`Iterator`
`iterator()`
`List<String>`
`localText()`
Returns the list of any direct String nodes of this NodeChild.
`String`
`namespaceURI()`
Returns the URI of the namespace of this NodeChild.
`Iterator`
`nodeIterator()`
`GPathResult`
`parent()`
Returns as GPathResult with the parent nodes of the current GPathResult
`GPathResult`
`parents()`
Throws a `GroovyRuntimeException`, because this method is not implemented yet.
`protected void`
`replaceBody(Object newValue)`
`protected void`
`replaceNode(Closure newValue)`
`int`
`size()`
Returns the size of this GPathResult.
`String`
`text()`
Returns the text of this GPathResult as a `String`.
`Writer`
`writeTo(Writer out)`
Writes this object to the given writer.

### Methods inherited from class groovy.util.slurpersupport.GPathResult

`breadthFirst, children, declareNamespace, depthFirst, equals, getAt, getBody, getProperty, hashCode, isEmpty, leftShift, list, lookupNamespace, name, plus, pop, putAt, setMetaClass, setProperty, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`

### Methods inherited from class groovy.lang.GroovyObjectSupport

`getMetaClass, invokeMethod`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Constructor Details

### NodeChild

public NodeChild(Node node, GPathResult parent, String namespacePrefix, Map<String,String> namespaceTagHints)

Parameters:
  `node` - a node
  `parent` - the GPathResult prior to the application of the expression creating this GPathResult
  `namespacePrefix` - the namespace prefix if any
  `namespaceTagHints` - the known tag to namespace mappings

### NodeChild

public NodeChild(Node node, GPathResult parent, Map<String,String> namespaceTagHints)

Parameters:
  `node` - a node
  `parent` - the GPathResult prior to the application of the expression creating this GPathResult
  `namespaceTagHints` - the known tag to namespace mappings

## Method Details

### parent

public GPathResult parent()
Description copied from class: `GPathResult`
Returns as GPathResult with the parent nodes of the current GPathResult

Overrides:
  `parent` in class `GPathResult`
Returns:
  the parents GPathResult or `this` for the root

### size

public int size()
Description copied from class: `GPathResult`
Returns the size of this GPathResult.

Specified by:
  `size` in class `GPathResult`
Returns:
  the size of this GPathResult

### text

public String text()
Description copied from class: `GPathResult`
Returns the text of this GPathResult as a `String`.

Specified by:
  `text` in class `GPathResult`
Returns:
  the text of this GPathResult

### localText

public List<String> localText()
Returns the list of any direct String nodes of this NodeChild.

Returns:
  the list of String values from this node
Since:
  2.3.0

### namespaceURI

public String namespaceURI()
Returns the URI of the namespace of this NodeChild.

Returns:
  the namespace of this NodeChild

### parents

public GPathResult parents()
Throws a `GroovyRuntimeException`, because this method is not implemented yet.

Specified by:
  `parents` in class `GPathResult`
Returns:
  the parents of this GPathResult

### iterator

public Iterator iterator()

Specified by:
  `iterator` in interface `Iterable`
Specified by:
  `iterator` in class `GPathResult`

### nodeIterator

public Iterator nodeIterator()

Specified by:
  `nodeIterator` in class `GPathResult`

### getAt

public Object getAt(int index)
Description copied from class: `GPathResult`
Supports the subscript operator for a GPathResult.

     import groovy.util.slurpersupport.*
     def text = """
     <characterList>
       <character/>
       <character>
         <name>Gromit</name>
       </character>
     </characterList>"""

     GPathResult characterList = new XmlSlurper().parseText(text)

     assert characterList.character[1].name == 'Gromit'

Overrides:
  `getAt` in class `GPathResult`
Parameters:
  `index` - an index
Returns:
  the value at the given index

### attributes

public Map attributes()
Returns a map containing all attributes of the Node of this NodeChild.

Returns:
  a map containing all attributes

### childNodes

public Iterator childNodes()
Description copied from class: `GPathResult`
Returns an iterator over the child nodes of this GPathResult.

Specified by:
  `childNodes` in class `GPathResult`
Returns:
  an iterator over the child nodes of this GPathResult

### find

public GPathResult find(Closure closure)
Description copied from class: `GPathResult`
Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.

Specified by:
  `find` in class `GPathResult`
Parameters:
  `closure` - a closure to filters the children of this GPathResult
Returns:
  the first child matching the closure

### findAll

public GPathResult findAll(Closure closure)
Description copied from class: `GPathResult`
Returns the children of this GPathResult matching the condition(s) specified in the passed closure.

Specified by:
  `findAll` in class `GPathResult`
Parameters:
  `closure` - a closure to filters the children of this GPathResult
Returns:
  the children matching the closure

### build

public void build(GroovyObject builder)

### writeTo

public Writer writeTo(Writer out) throws IOException
Description copied from interface: `Writable`
Writes this object to the given writer.

This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as is may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

Parameters:
  `out` - the Writer to which this Writable should output its data.
Returns:
  the Writer that was passed
Throws:
  `IOException` - if an error occurred while outputting data to the writer

### replaceNode

protected void replaceNode(Closure newValue)

Specified by:
  `replaceNode` in class `GPathResult`

### replaceBody

protected void replaceBody(Object newValue)

Specified by:
  `replaceBody` in class `GPathResult`

### appendNode

protected void appendNode(Object newValue)

Specified by:
  `appendNode` in class `GPathResult`